#----------------------------------------------------------------------
# Licensed materials - Property of IBM
#
# 5655-FIN
# 5724-D96
#
# (C) Copyright IBM Corp. 2002, 2009  All Rights Reserved.
#
# US Government Users Restricted Rights - Use, duplication
# or disclosure restricted by GSA ADP Schedule Contract
# with IBM Corp.
#----------------------------------------------------------------------

BEGIN {
  FS=" ";
  rc=0;
}

{
  # ============================================================================
  # collect all existing Roles in ro_tab and all existing Roles with CT/CO/Attr in ro_ct_co_tab
  # ============================================================================

  if (x == 0) {
    if ($1 == "DNIU7050I") {
      ro_tab[$2]= 1;
      #printf "x=1, %s %s %s %s %s\n", $1, $2, $3, $4, $5;
      if ($3 != "-") {
        ro_ct_co_tab[$2, $3, $4, $5]= 1;
        printf "DnfInfo: Ro=%s CT=%s CO=%s ATTR=%s found in system\n", $2, $3, $4, $5 >> logFile;
        #printf "DnfInfo: Ro=%s CT=%s CO=%s ATTR=%s found in system\n", $2, $3, $4, $5;
      }
    }
  }


  # ============================================================================
  # collect all existing CTs in ct_tab
  # ============================================================================

  if (x == 1) {
    if ($1 == "DNIP3300I") {
      #printf "x=2, %s %s\n", $1, $2;
      ct_tab[$2]= 1;
    }
  }


  # ============================================================================
  # collect all existing CTs with attribute and types in ct_attr_tab
  # ============================================================================

  if (x == 2) {
    if ($1 == "DNIP3300I") {
      #printf "x=3, %s %s %s %s\n", $1, $2, $3, $4;
      if ($3 != "-") {
        ct_attr_tab[$2, $3, $4]= 1;
        printf "DnfInfo: CT=%s ATTR=%s TYPE=%s found in system\n", $2, $3, $4 >> logFile;
      }
    }
  }

  # ============================================================================
  # collect all existing COs for CTs with OU in co_tab and 
  #  all existing COs for CTs with OU, attribute, type and values in co_attr_tab
  # ============================================================================

  if (x == 3) {
    if ($1 == "DNIP3301I") {
      #printf "x=5%s, %s %s %s %s %s",NF, $1, $2, $3, $4, $5;
      co_tab[$2, $3, $4]= 1;
      if (NF == 6){
      	#printf "x=6, %s %s %s %s %s %s\n", $1, $2, $3, $4, $5, $6;
        co_attr_tab[$2, $3, $4, $5, $6] = 1;
        #printf "DnfInfo: OU=%s CT=%s CO=%s ATTR=%s TYPE=%s found in system\n", $2, $3, $4, $5, $6;
        printf "DnfInfo: OU=%s CT=%s CO=%s ATTR=%s TYPE=%s found in system\n", $2, $3, $4, $5, $6 >> logFile;
      }
      else
      {
      	val = $7;
      	for (i=8; i<=NF; i++){
      	  #printf " %s", %i;  
      	  val = sprintf("%s %s",val,$i); 
        }
        co_attr_tab[$2, $3, $4, $5, $6, val] = 1;
        #printf "\nDnfInfo: OU=%s CT=%s CO=%s ATTR=%s TYPE=%s VAL=%s found in system\n", $2, $3, $4, $5, $6, val;
        printf "DnfInfo: OU=%s CT=%s CO=%s ATTR=%s TYPE=%s VAL=%s found in system\n", $2, $3, $4, $5, $6, val >> logFile;
      }
    }
  }


  # ============================================================================
  # collect all for Special migration additional required COs in co_spec_attr_tab
  # ============================================================================

  if (x == 4) {
    if ($1 == "DNIP3301I") {
      #printf "x=6, %s %s %s %s %s\n", $1, $2, $3, $4, $5;
      co_spec_attr_tab[$2, $3, $4, $5] = 1;
      #printf "DnfInfo: OU=%s CT=%s CO=%s ATTR=%s found in system\n", $2, $3, $4, $5;
      printf "DnfInfo: OU=%s CT=%s CO=%s ATTR=%s found in system\n", $2, $3, $4, $5 >> logFile;
    }
  }


  # ============================================================================
  # collect all OUs which are used as ESN business OUs in bou_tab
  # ============================================================================

  if (x == 5) {
    if ($1 == "DNIP3301I") {
      bou_tab[$2] = 1;
      printf "DnfInfo: OU=%s as BOU found in system\n", $2 >> logFile;
    }
  }


  # ============================================================================
  # add all 'old' CTs/ROs from file to ct_in_history_tab/ro_in_history_tab
  # ============================================================================

  if (x == 6) {
    entrytype = $1;
    n = gsub("\\\\", "", entrytype);
    entry = $2;
    n = gsub("\\\\", "", entry);
    subentry = $3;
    n = gsub("\\\\", "", subentry);
    if ((entrytype != "") && (entry != "")) {
      if (entrytype == "ct") {
        #printf "Old ressource found:  CT=%s\n", entry;
        ct_in_history_tab[entry]=1;
      } else if (entrytype == "ro") {
        #printf "Old ressource found:  RO=%s\n", entry;
        ro_in_history_tab[entry]=1;
      } else if (entrytype == "attr") {
        #printf "Old ressource found:  CT=%s ATTR=%s\n", entry, subentry;
        attr_in_history_tab[entry,subentry]=1;
      } else if (entrytype == "migrate"){
      	if (entry == "ct"){
      	  ct1 = $3;
      	  n = gsub("\\\\", "", ct1);
      	  ct2 = $4;
      	  n = gsub("\\\\", "", ct2);
      	  #printf "Migrate CT resource found:  from CT=%s to CT=%s\n", ct1, ct2;
      	  migct_in_his_tab[ct1,ct2]=1;
        } else if (entry == "attr"){
      	  ct1 = $3;
      	  n = gsub("\\\\", "", ct1);
      	  attr1 = $4;
      	  n = gsub("\\\\", "", attr1);
      	  ct2 = $5;
      	  n = gsub("\\\\", "", ct2);
      	  attr2 = $6;
      	  n = gsub("\\\\", "", attr2);
      	  defval = "";
      	  if (NF>6){
      	    defval = $7;
      	    for (i=8; i<=NF; i++){
      	      #printf " %s", %i;  
      	      defval = sprintf("%s %s",defval,$i); 
            }
          }
      	  #printf "Migrate Attr resource found:  from CT=%s attr=%s to CT=%s attr=%s\n", ct1, attr1, ct2, attr2;
      	  migattr_in_his_tab[ct1,attr1,ct2,attr2,defval]=1;
        } else if (entry == "defval"){
          ct1 = $3;
          n = gsub("\\\\", "", ct1);
          attr1 = $4;
          n = gsub("\\\\", "", attr1);
          defval = "";
      	  if (NF>4){
      	    defval = $5; 
      	    for (i=6; i<=NF; i++){
      	      #printf " %s", %i;  
      	      defval = sprintf("%s %s",defval,$i); 
            }  
          }
          #printf "Migrate default value resource found:  set value %s for CT=%s attr=%s \n", defval, ct1, attr1;
          defval_in_his_tab[ct1,attr1,defval]=1;
        } else if (entry == "refval"){
          ct1 = $3;
          n = gsub("\\\\", "", ct1);
          attr1 = $4;
          n = gsub("\\\\", "", attr1);
          refval = "";
      	  if (NF>4){
      	    refval = $5 
      	    for (i=6; i<=NF; i++){
      	      #printf " %s", %i;  
      	      refval = sprintf("%s %s",refval,$i); 
            }  
          }
          #printf "Migrate reference value resource found:  set reference value %s for CT=%s attr=%s \n", refval, ct1, attr1;
          refval_in_his_tab[ct1,attr1,refval]=1;
        } else if (entry == "supval"){
          ct1 = $3;
          n = gsub("\\\\", "", ct1);
          attr1 = $4;
          n = gsub("\\\\", "", attr1);
          #printf "supval resource found:  supval resource for CT=%s attr=%s \n",ct1, attr1;
          supval_in_his_tab[ct1,attr1]=1;
        }
      }
    }
  }


  # ============================================================================
  # collect all existing CTs with attribute and types from file and store in
  # file_ct_tab and file_ct_attr_tab
  # ============================================================================

  if (x == 7){
    ct = "";
    attr = "";
    type = "R";
    desc = "";
    if ($1 == "add") {
      ct_index = 0;
      attr_index = 0;
      type_index = 0;
      for (i=2; i<=NF; i++) {
        if ($i == "-ct") {
          ct_index = i+1;
        }
        if ($i == "-attr") {
          attr_index = i+1;
        }
        if ($i == "-type") {
          type_index = i+1;
        }
      }
      if (ct_index > 0) ct = $ct_index;
      if (attr_index > 0) attr = $attr_index;
      if (type_index > 0) type = $type_index;
      n = gsub("\\\\", "", ct);
      n = gsub("\\\\", "", attr);
      if (ct != "") {
        #printf "CT=%s ATTR=%s TYPE=%s\n", ct, attr, type;
        file_ct_attr_tab[ct,attr,type]=1;
        printf "DnfInfo: CT=%s ATTR=%s TYPE=%s found in file\n", ct, attr, type >> logFile;
      }
    }

    if ($1 == "cre") {
      ct_index = 0;
      desc_index = 0;
      for (i=2; i<=NF; i++) {
        if ($i == "-ct") {
          ct_index = i+1;
        }
        if ($i == "-desc") {
          desc_index = i+1;
        }
      }
      if (ct_index > 0) ct = $ct_index;
      if (desc_index > 0){ 
      	for (i=desc_index; i<=NF; i++){
      	  desc = sprintf("%s %s",desc,$i); 
        }
      }
      n = gsub("\\\\", "", ct);
      if (ct != "") {
        #printf "CT=%s DESC=%s\n", ct, desc;
        file_ct_tab[ct,desc]=1;
        ct_in_product_tab[ct]=1;
        printf "DnfInfo: CT=%s found in file\n", ct >> logFile;
      }
    }
  }


  # ============================================================================
  # collect all existing Roles with CT / CO / attribute from file and store in
  # file_ro_tab and file_ro_ct_co_tab
  # ============================================================================

  if (x == 8) {
    ro = "";
    ct = "";
    co = "";
    attr = "";
    if ($1 == "add") {
      ro_index = 0;
      ct_index = 0;
      co_index = 0;
      attr_index = 0;
      for (i=2; i<=NF; i++) {
        if ($i == "-ro") {
          ro_index = i+1;
        }
        if ($i == "-ct") {
          ct_index = i+1;
        }
        if ($i == "-co") {
          co_index = i+1;
        }
        if ($i == "-attr") {
          attr_index = i+1;
        }
      }
      if (ro_index > 0) ro = $ro_index;
      if (ct_index > 0) ct = $ct_index;
      if (co_index > 0) co = $co_index;
      if (attr_index > 0) attr = $attr_index;
      if (ro != "") {
        #printf "Ro=%s CT=%s CO=%s ATTR=%s\n", ro, ct, co, attr;
        file_ro_ct_co_tab[ro,ct,co,attr]=1;
        printf "DnfInfo: Ro=%s CT=%s CO=%s ATTR=%s found in file.\n", ro, ct, co, attr >> logFile;
      }
    }

    if ($1 == "cre") {
      ro_index = 0;
      for (i=2; i<=NF; i++) {
        if ($i == "-ro") {
          ro_index = i+1;
        }
      }
      if (ro_index > 0) ro = $ro_index;
      if (ro != "") {
        #printf "Ro=%s\n", ro;
        file_ro_tab[ro]=1;
        ro_in_product_tab[ro]=1;
        printf "DnfInfo: Ro=%s found in file\n", ro >> logFile;
      }
    }
  }
  # ============================================================================
  # collect all existing COs for CTs with OU, attribute, type and values from file 
  # and store in file_co_attr_tab
  # ============================================================================

  if (x == 9) {
    ct = "";
    ou = "";
    co = "";
    attr = "";
    type = "R";
    val = "";
    if ($1 == "add") {
      ct_index = 0;
      ou_index = 0;
      co_index = 0;
      attr_index = 0;
      svb_index = 0;
      val_index = 0;
      for (i=2; i<=NF; i++) {
        if ($i == "-ct") {
          ct_index = i+1;
        }
        if ($i == "-ou") {
          ou_index = i+1;
        }
        if ($i == "-co") {
          co_index = i+1;
        }
        if ($i == "-attr") {
          attr_index = i+1;
        }
        if ($i == "-svb") {
          svb_index = i+1;
        }
        if ($i == "-val") {
          val_index = i+1;
        }
      }
      if (ct_index > 0) ct = $ct_index;
      if (ou_index > 0) ou = $ou_index;      
      if (co_index > 0) co = $co_index;
      if (attr_index > 0) attr = $attr_index;
      if (svb_index > 0) svb = $svb_index;
      if (val_index > 0) val = $val_index;
      n = gsub("\\\\", "", ct);
      n = gsub("\\\\", "", co);
      if (ct != "") {
        #printf "Ou=%s CT=%s CO=%s ATTR=%s\n", ou, ct, co, attr;
        if (val == ""){
          file_co_attr_tab[ou,ct,co,attr,"P",svb]=1;
        }else{
          file_co_attr_tab[ou,ct,co,attr,type,svb,val]=1;
        }
        printf "DnfInfo: CT=%s OU=%s CO=%s ATTR=%s SVB=%s VAL=%s found in file.\n", ct, ou, co, attr, svb, val >> logFile;
      }
    }
    if ($1 == ";@migrate") {
      if ($2 == "add") {
        ct_index = 0;
        ou_index = 0;
        co_index = 0;
        attr_index = 0;
        svb_index = 0;
        val_index = 0;
        for (i=2; i<=NF; i++) {
          if ($i == "-ct") {
            ct_index = i+1;
          }
          if ($i == "-ou") {
            ou_index = i+1;
          }
          if ($i == "-co") {
            co_index = i+1;
          }
          if ($i == "-attr") {
            attr_index = i+1;
          }
          if ($i == "-svb") {
            svb_index = i+1;
          }
          if ($i == "-val") {
            val_index = i+1;
          }
        }
        if (ct_index > 0) ct = $ct_index;
        if (ou_index > 0) ou = $ou_index;      
        if (co_index > 0) co = $co_index;
        if (attr_index > 0) attr = $attr_index;
        if (svb_index > 0) svb = $svb_index;
        if (val_index > 0) val = $val_index;
        n = gsub("\\\\", "", ct);
        n = gsub("\\\\", "", co);
        if (ct != "") {
          #printf "OU=%s CT=%s CO=%s ATTR=%s\n", ou, ct, co, attr;
          if (val == ""){
            file_co_attr_tab_manadd[ou,ct,co,attr,"P",svb]=1;
          }else{
            file_co_attr_tab_manadd[ou,ct,co,attr,type,svb,val]=1;
          }
          printf "DnfInfo: CT=%s OU=%s CO=%s ATTR=%s SVB=%s VAL=%s found for mandatory added in file.\n", ct, ou, co, attr, val, svb >> logFile;
        }
      }
      if ($2 == "rem") {
        ct_index = 0;
        ou_index = 0;
        co_index = 0;
        attr_index = 0;
        val_index = 0;
        for (i=2; i<=NF; i++) {
          if ($i == "-ct") {
            ct_index = i+1;
          }
          if ($i == "-ou") {
            ou_index = i+1;
          }
          if ($i == "-co") {
            co_index = i+1;
          }
          if ($i == "-attr") {
            attr_index = i+1;
          }
          if ($i == "-val") {
            val_index = i+1;
          }
        }
        if (ct_index > 0) ct = $ct_index;
        if (ou_index > 0) ou = $ou_index;      
        if (co_index > 0) co = $co_index;
        if (attr_index > 0) attr = $attr_index;
        if (val_index > 0) val = $val_index;
        if (ct != "") {
          #printf "OU=%s CT=%s CO=%s ATTR=%s VAL=%s\n", ou, ct, co, attr, val;
          file_co_attr_tab_manrem[ou,ct,co,attr,val]=1;
          printf "DnfInfo: CT=%s OU=%s CO=%s ATTR=%s VAL=%s found for mandatory removed in file.\n", ct, ou, co, attr, val >> logFile;
        }
      }
    }
  }


}
END {

  if (rc == 0) {

    CreRoEntry = 0;
    RemRoEntry = 0;
    CreCTEntry = 0;
    RemCTEntry = 0;
    CreCOEntry = 0;
    RemCOEntry = 0;
    ValEntry = 0;

    # ============================================================================
    # Initialize CLI command files
    # ============================================================================

    # Create RO
    printf "; CLI command file to create roles:\n" > CreRoCom;
    printf "; CLI command file to approve roles:\n" > CreRoApp;

    # Remove RO
    printf "; CLI command file to remove roles:\n" > RemRoCom;
    printf "; CLI command file to approve role removals:\n" > RemRoApp;

    # Create CT
    printf "; CLI command file to create configuration types:\n" > CreCTCom;
    printf "; CLI command file to deploy configuration types:\n" > CreCTDep;

    # Remove CT
    printf "; CLI command file to remove configuration types:\n" > RemCTCom;
    printf "; CLI command file to deploy configuration type removals:\n" > RemCTDep;

    # Create CO
    printf "; CLI command file to create configuration objects:\n" > CreCOCom;
    printf "; optional value change: remove the comment sign, if you want to activate the following setting.\n" >> CreCOCom;
    printf "; CLI command file to deploy configuration objects:\n" > CreCODep;
    printf "; optional value change: remove the comment sign, if you want to activate the following setting.\n" >> CreCODep;

    # Remove CO
    printf "; CLI command file to remove configuration objects:\n" > RemCOCom;
    printf "; CLI command file to deploy configuration objects removals:\n" > RemCODep;

    # Values to COs
    printf "; CLI command file to add attributes with value to configuration objects:\n" > ValCom;
    printf "; CLI command file to deploy attributes with value:\n" > ValDep;

    # --------------------------------------------------------------------
    # For all OUs used as BOUs in CSN/MSIF/MM
    # --------------------------------------------------------------------

    for (i in bou_tab) {
      n = split(i, fields, SUBSEP);
      ou = fields[1];
      remOneBou = ou;
      
      # -------------------------------------------------------------------------------
      # Create CO scripts for manadatory remove part from annotation ;migrate rem
      # --------------------------------------------------------------------------------      
      for (j in file_co_attr_tab_manrem) {
        n = split(j, fields, SUBSEP);
        ou = fields[1];
        ct = fields[2];
        co = fields[3];
        attr = fields[4];
        val = fields[5];
        if ((ou == "DNIvOU") && (remOneBou != "DNFSYSOU") && (remOneBou != "SYSOU" )){ 
          ou = remOneBou;
        }else if (ou == remOneBou) {
          ou = fields[1];
        }else continue;        
        ou1 = ou;
        n = gsub(strBSUL, "_", ou1);
        n = gsub(strBSPC, "%", ou1);
        ct1 = ct;
        n = gsub(strBSUL, "_", ct1);
        n = gsub(strBSPC, "%", ct1);
        co1 = co;
        n = gsub(strBSUL, "_", co1);
        n = gsub(strBSPC, "%", co1);
        attr1 = attr;
        n = gsub(strBSUL, "_", attr1);
        n = gsub(strBSPC, "%", attr1);
        val1 = val;
        n = gsub(strBSUL, "_", val1);
        n = gsub(strBSPC, "%", val1);
        if (((val1=="") && (co_spec_attr_tab[ou1, ct1, co1, attr1] == 1))||((val1!="") && (co_attr_tab[ou1, ct1, co1, attr1, "R", val1] == 1))) {
            printf "DnfInfo: CT=%s ATTR=%s used in OU=%s within CO=%s (REMOVE).\n", ct, attr, ou, co >> logFile;
            printf "DnfInfo: CT=%s ATTR=%s used in OU=%s within CO=%s will be removed.\n", ct, attr, ou, co >> infologFile;
            printf "rem -ou %s -ct %s -co %s -attr %s\n", ou, ct, co, attr >> RemCOCom;
            # ===========================================================================
            # remember OUs in which a CO was found
            # ============================================================================
            co_spec_attr_tab[ou1, ct1, co1, attr1]=0;
            rem_ou_used[ou]=1;
        }
      }

      # -------------------------------------------------------------------------------
      # Create CO scripts for manadatory add part from annotation ;migrate add
      # --------------------------------------------------------------------------------   
      for (j in file_co_attr_tab_manadd) {
        ns = split(j, fields, SUBSEP);
        ou = fields[1];
        if ((ou == "DNIvOU") && ( remOneBou != "DNFSYSOU" ) && (remOneBou != "SYSOU" )){ 
          ou = remOneBou;  
        }else if (ou == remOneBou) {
          ou = fields[1];
        }else continue;
        ct = fields[2];
        co = fields[3];
        attr = fields[4];
        type = fields[5];
        svb = fields[6];
        ou1 = ou;
        n = gsub(strBSUL, "_", ou1);
        n = gsub(strBSPC, "%", ou1);
        ct1 = ct;
        n = gsub(strBSUL, "_", ct1);
        n = gsub(strBSPC, "%", ct1);
        co1 = co;
        n = gsub(strBSUL, "_", co1);
        n = gsub(strBSPC, "%", co1);
        attr1 = attr;
        n = gsub(strBSUL, "_", attr1);
        n = gsub(strBSPC, "%", attr1);
        svb1 = svb;
        n = gsub(strBSUL, "_", svb1);
        n = gsub(strBSPC, "%", svb1);
        #printf "debug: %s,%s,%s,%s,%s\n", ou, ct, co, attr, type >> CreCOCom;
        real_attr = 0;
        valid = 0;
        if (ns == 7){
          real_attr = 1;
          val = fields[7];    
          val1  = val;
          n = gsub(strBSUL, "_", val1);
          n = gsub(strBSPC, "%", val1);   
          n = gsub("DNIvOU", ou1 , val1);
        }

        #Check if the SVB of the statement is generally loaded in this OU
        if (co_spec_attr_tab[ou1, ct1, co1, attr1] != 1){
          if (svb1 == "DNFCOMMON") {
            svb_ct = "DniComOU";
            svb_co = "DnfComOU";
            svb_attr = "na";
            if (ou1 == "SYSOU" || ou1 == "DNFSYSOU" || co_spec_attr_tab[ou1, svb_ct, svb_co, svb_attr] == 1) {
              valid = 1; 
            }
          }
          if (svb1 == "DNFFCOMMON") {
            svb_ct = "DniOptionsMsgAudit";
            svb_co = "DnfIlcFinAudit";
            svb_attr = "DniFlagMsgAudit";
            if (ou1 == "SYSOU" || ou1 == "DNFSYSOU" || co_spec_attr_tab[ou1, svb_ct, svb_co, svb_attr] == 1) {
              valid = 1; 
            }
          }
          if (svb1 == "DNFEFAS") {
            svb_ct = "DnfEfaFtAccessControl";
            svb_co = "DnfEfaFtAccessControl";
            svb_attr = "snd";
            if (ou1 == "SYSOU" || ou1 == "DNFSYSOU" || co_spec_attr_tab[ou1, svb_ct, svb_co, svb_attr] == 1) {
              valid = 1; 
            }
          }
          if (svb1 == "DNQCOMMON") {
            svb_ct = "DnqOptionsMwh";
            svb_co = "DnqMwhOptionsPrint";
            svb_attr = "DnqFlagMwh";
            if (ou1 == "SYSOU" || ou1 == "DNFSYSOU" || co_spec_attr_tab[ou1, svb_ct, svb_co, svb_attr] == 1) {
              valid = 1; 
            }
          }
          if (svb1 == "DNQERBS") {
            svb_ct = "DnqERQueue";
            svb_co = "FIN1Input";
            svb_attr = "USE";
            if (ou1 == "SYSOU" || ou1 == "DNFSYSOU" || co_spec_attr_tab[ou1, svb_ct, svb_co, svb_attr] == 1) {
              valid = 1; 
            }
          }
        }

        if (valid == 1) {        
          if (real_attr == 1){
            printf "add -ou %s -ct %s -co %s -attr %s -val %s\n", ou1, ct1, co1, attr, val1 >> CreCOCom;
          } else {
            printf "add -ou %s -ct %s -co %s -attr %s\n", ou1, ct1, co1, attr1 >> CreCOCom;
          }
          co_attr_tab_add[ou1, ct1, co1, attr1] = 1;
          cre_ou_used[ou]=1;                
        }
      }

      # -------------------------------------------------------------------------------
      # Create CO scripts for optional part
      # --------------------------------------------------------------------------------   
      for (j in file_co_attr_tab) {
        ns = split(j, fields, SUBSEP);
        ou = fields[1];
        if ((ou == "DNIvOU") && ( remOneBou != "DNFSYSOU" ) && (remOneBou != "SYSOU" )){ 
          ou = remOneBou;
        }else if (ou == remOneBou) {
          ou = fields[1];
        }else continue;
        ct = fields[2];
        co = fields[3];
        attr = fields[4];
        type = fields[5];
        svb = fields[6];
        ou1 = ou;
        n = gsub(strBSUL, "_", ou1);
        n = gsub(strBSPC, "%", ou1);
        ct1 = ct;
        n = gsub(strBSUL, "_", ct1);
        n = gsub(strBSPC, "%", ct1);
        co1 = co;
        n = gsub(strBSUL, "_", co1);
        n = gsub(strBSPC, "%", co1);
        attr1 = attr;
        n = gsub(strBSUL, "_", attr1);
        n = gsub(strBSPC, "%", attr1);

        svb1 = svb;
        n = gsub(strBSUL, "_", svb1);
        n = gsub(strBSPC, "%", svb1);
        #printf "debug: %s,%s,%s,%s,%s\n", ou, ct, co, attr, type >> CreCOCom;
        real_attr = 0;
        valid = 0;
        if (ns == 7){
          real_attr = 1;
          val = fields[7];    
          val1  = val;
          n = gsub(strBSUL, "_", val1);
          n = gsub(strBSPC, "%", val1);   
          n = gsub("DNIvOU", ou1 , val1);
        }

        #printf ";add -ou %s -ct %s -co %s -attr %s -val %s\ -svb %s\n", ou1, ct1, co1, attr, val1, svb1 ;

        #Check if the SVB of the statement is generally loaded in this OU
        if ((co_attr_tab_add[ou1, ct1, co1, attr1]!=1) && (co_spec_attr_tab[ou1, ct1, co1, attr1] != 1) && (index(val1, "DNIv")==0) && (index(val1,"DNFv")==0)){
          if (svb1 == "DNFCOMMON") {
            svb_ct = "DniComOU";
            svb_co = "DnfComOU";
            svb_attr = "na";
            if (co_spec_attr_tab[ou1, svb_ct, svb_co, svb_attr] == 1) {
              valid = 1; 
            }
          }
          if (svb1 == "DNFFCOMMON") {
            svb_ct = "DniOptionsMsgAudit";
            svb_co = "DnfIlcFinAudit";
            svb_attr = "DniFlagMsgAudit";
            if (co_spec_attr_tab[ou1, svb_ct, svb_co, svb_attr] == 1) {
              valid = 1; 
            }
          }
          if (svb1 == "DNFEFAS") {
            svb_ct = "DnfEfaFtAccessControl";
            svb_co = "DnfEfaFtAccessControl";
            svb_attr = "snd";
            if (co_spec_attr_tab[ou1, svb_ct, svb_co, svb_attr] == 1) {
              valid = 1; 
            }
          }
          if (svb1 == "DNQCOMMON") {
            svb_ct = "DnqOptionsMwh";
            svb_co = "DnqMwhOptionsPrint";
            svb_attr = "DnqFlagMwh";
            if (co_spec_attr_tab[ou1, svb_ct, svb_co, svb_attr] == 1) {
              valid = 1; 
            }
          }
          if (svb1 == "DNQERBS") {
            svb_ct = "DnqERQueue";
            svb_co = "FIN1Input";
            svb_attr = "USE";
            if (co_spec_attr_tab[ou1, svb_ct, svb_co, svb_attr] == 1) {
              valid = 1; 
            }
          }
        }

        if (valid == 1) {        
          if (real_attr == 1){
            printf ";add -ou %s -ct %s -co %s -attr %s -val %s\n", ou1, ct1, co1, attr, val1 >> CreCOCom;
          } else {
            printf ";add -ou %s -ct %s -co %s -attr %s\n", ou1, ct1, co1, attr1 >> CreCOCom;
          }
          co_attr_tab_add[ou1, ct1, co1, attr1] = 1;
          com_cre_ou_used[ou]=1;
        }
      }
    }


    # ============================================================================
    # Standard migration part (dnfczcat.cli, dnfczcar.cli)
    # ============================================================================




    # ============================================================================
    # Remove all CTs with their COs which exist in the system but not in the file
    # ============================================================================
    for (i in co_attr_tab) {
       n = split(i, fields, SUBSEP);
       ou = fields[1];
       ct= fields[2];
       co = fields[3];
       attr = fields[4];
       type = fields[5];
       val = fields[6];
       #printf "CO_ATTR_TAB: DnfInfo: OU=%s CT=%s CO=%s Attr=%s Type=%s.\n", ou, ct, co, attr, type;
       ou1 = ou;
       n = gsub("_", strBSUL, ou1);
       n = gsub("%", strBSPC, ou1);
       ct1 = ct;
       n = gsub("_", strBSUL, ct1);
       n = gsub("%", strBSPC, ct1);
       co1 = co;
       n = gsub("_", strBSUL, co1);
       n = gsub("%", strBSPC, co1);
       attr1 = attr;
       n = gsub("_", strBSUL, attr1);
       n = gsub("%", strBSPC, attr1);
       val1 = val;
       n = gsub("_", strBSUL, val1);
       n = gsub("%", strBSPC, val1);
       for (j in migattr_in_his_tab){
         # ============================================================================
         # Special section for Attributes related value migration
         # ============================================================================      	 
         n = split(j, fields, SUBSEP);
      	 mct1 = fields[1];
      	 mattr1 = fields[2];
      	 mct2 = fields[3];
      	 mattr2 = fields[4];
      	 defval = fields[5];      	

      	 if (defval == "") insval = val1;
      	 else insval = defval;
      	 if ((mct1 == ct) && (mattr1 == attr) && (co_attr_tab_add[ou1, mct2, co1, mattr2] !=1 ) && (co_attr_tab[ou1, mct2, co, mattr2, type, insval] !=1 )){
           #printf "CO_ATTR_TAB: DnfInfo: OU=%s CT=%s CO=%s Attr=%s Type=%s.\n", ou, ct, co, attr, type;
           #printf "MIG_ATTR_TAB: DnfInfo: CT1=%s ATTR1=%s CT2=%s ATTR2=%s.\n", mct1, mattr1, mct2, mattr2;
           printf "DnfInfo: CT=%s ATTR=%s VAL=%s used in OU=%s within CO=%s (MIGRATE).\n", ct, attr, insval, ou, co >> logFile;
           printf "DnfInfo: CT=%s ATTR=%s VAL=%s used in OU=%s within CO=%s will be migrated.\n", ct, attr, insval, ou, co >> infologFile;
           if ((file_ct_attr_tab[mct2,mattr2,"R"]==1)&&((type=="R")||(defval!=""))){       	   
       	     if (index(insval, " ")==0) printf "add -ou %s -ct %s -co %s -attr %s -val %s\n", ou1, mct2, co1, mattr2, insval >> CreCOCom;
             else printf "add -ou %s -ct %s -co %s -attr %s -val '%s'\n", ou1, mct2, co1, mattr2, insval >> CreCOCom;
             co_attr_tab_add[ou1, mct2, co, mattr2] = 1;
             co_attr_tab_add[ou1, mct2, co1, mattr2] = 1;
             cre_ou_used[ou]=1;
           }else if ((file_ct_attr_tab[mct2,mattr2,"P"]==1)&&(type=="P")){       	   
             printf "add -ou %s -ct %s -co %s -attr %s\n", ou1, mct2, co1, mattr2>> CreCOCom;
             co_attr_tab_add[ou1, mct2, co, mattr2] = 1;
             co_attr_tab_add[ou1, mct2, co1, mattr2] = 1;
             cre_ou_used[ou]=1;
           }
      	 } 
       }  
       
       for (j in defval_in_his_tab){
         # ============================================================================
         # Special section for default value setting for new release
         # ============================================================================
         n = split(j, fields, SUBSEP);
         mct1 = fields[1];
         mattr1 = fields[2];
         defval = fields[3];
         if ((mct1 == ct) && (mattr1 == attr) && (co_attr_tab_add[ou1, mct1, co1, mattr1]!=1) && (co_attr_tab[ou1, mct1, co, mattr1, type, defval] !=1 ) && (co_attr_tab[ou1, mct1, co, mattr1, type, val] !=1 )){
           #printf "CO_ATTR_TAB: DnfInfo: OU=%s CT=%s CO=%s Attr=%s Type=%s.\n", ou1, ct1, co1, attr1, type;
           printf "DnfInfo: CT=%s ATTR=%s VAL=%s used in OU=%s within CO=%s (Default value setting).\n", ct1, mattr1, defval, ou1, co1 >> logFile;
           printf "DnfInfo: CT=%s ATTR=%s VAL=%s used in OU=%s within CO=%s will be set.\n", ct1, mattr1, defval, ou1, co1 >> infologFile;
           if ((file_ct_attr_tab[mct1,mattr1,"R"]==1)&&(type=="R")){
             if (index(defval, " ")==0) printf "add -ou %s -ct %s -co %s -attr %s -val %s\n", ou1, mct1, co1, mattr1, defval >> CreCOCom;
             else printf "add -ou %s -ct %s -co %s -attr %s -val '%s'\n", ou1, mct1, co1, mattr1, defval >> CreCOCom;
             co_attr_tab_add[ou1, mct1, co1, mattr1] = 1;
             cre_ou_used[ou]=1;
           }
         }
       }
       for (j in refval_in_his_tab){
         # ============================================================================
         # Special section for reference value setting for new release
         # ============================================================================
         n = split(j, fields, SUBSEP);
         mct1 = fields[1];
         mattr1 = fields[2];
         refval = fields[3];
         if ((mct1 == ct) && (mattr1 == attr) && (co_attr_tab_add[ou1, mct1, co1, mattr1]!=1) && (co_attr_tab[ou1, mct1, co, mattr1, type, refval] !=1 ) && (co_attr_tab[ou1, mct1, co, mattr1, type, val] !=1 )){
           #printf "CO_ATTR_TAB: DnfInfo: OU=%s CT=%s CO=%s Attr=%s Type=%s VAL=%s.\n", ou1, ct1, co1, attr1, type, val1;
           printf "DnfInfo: CT=%s ATTR=%s VAL=%s used in OU=%s within CO=%s (Reference value setting).\n", ct1, mattr1, refval, ou1, co1 >> logFile;
           printf "DnfInfo: CT=%s ATTR=%s VAL=%s used in OU=%s within CO=%s will be set.\n", ct1, mattr1, refval, ou1, co1 >> infologFile;
           if ((file_ct_attr_tab[mct1,mattr1,"R"]==1)&&(type=="R")){
             if (index(refval, " ")==0) printf ";add -ou %s -ct %s -co %s -attr %s -val %s\n", ou1, mct1, co1, mattr1, refval >> CreCOCom;
             else printf ";add -ou %s -ct %s -co %s -attr %s -val '%s'\n", ou1, mct1, co1, mattr1, refval >> CreCOCom;
             co_attr_tab_add[ou1, mct1, co1, mattr1] = 1;
             cre_ou_used[ou]=1;
           }
         }
       }
 
       for (j in migct_in_his_tab){
         # ============================================================================
         # Special section for CT related value migration
         # ============================================================================      	 
         n = split(j, fields, SUBSEP);
      	 mct1 = fields[1];
      	 mct2 = fields[2];
      	 insval = val1;
  	 
         if (mct1 == ct){
           mig_co_attr_tab_add[ou1, mct1, mct2, co1, attr1] = 1;
           if ((co_attr_tab_add[ou1, mct2, co1, attr1] !=1 ) && (co_attr_tab[ou1, mct2, co, attr1, type, val] !=1 )){
       	   if (file_ct_attr_tab[mct2,attr1,"R"]==1){
       	     #printf "file_ct_attr_tab: %s\n", file_ct_attr_tab[mct2,attr1,"R"] >> CreCOCom;
             refval_found = 0;             
             for (k in defval_in_his_tab){
               # ============================================================================
               # Special section for default value setting also in migrate CT table
               # ============================================================================
               n = split(k, fields, SUBSEP);
               mdct1 = fields[1];
               mdattr1 = fields[2];
               defval = fields[3];
               if ((mct2 == mdct1) && (attr1 == mdattr1)) insval = defval;
             }
             for (k in refval_in_his_tab){
               # ============================================================================
               # Special section for reference value setting also in migrate CT table
               # ============================================================================
               n = split(k, fields, SUBSEP);
               mrct1 = fields[1];
               mrattr1 = fields[2];
               refval = fields[3];
               if ((mct2 == mrct1) && (attr1 == mrattr1)){
                 insval = refval;
                 refval_found = 1;
               }
             }
      	     #printf "CO_ATTR_TAB: DnfInfo: OU=%s CT=%s CO=%s Attr=%s Type=%s.\n", ou, ct, co, attr, type;
             #printf "MIG_CT_TAB: DnfInfo: CT1=%s CT2=%s.\n", mct1, mct2;
             printf "DnfInfo: CT=%s ATTR=%s VAL=%s used in OU=%s within CO=%s (MIGRATE).\n", ct, attr, insval, ou, co >> logFile;
             printf "DnfInfo: CT=%s ATTR=%s VAL=%s used in OU=%s within CO=%s will be migrated.\n", ct, attr, insval, ou, co >> infologFile;
       	     if (refval_found == 1) printf ";" >> CreCOCom;
       	     if (index(insval, " ")==0) printf "add -ou %s -ct %s -co %s -attr %s -val %s\n", ou1, mct2, co1, attr1, insval >> CreCOCom;
             else printf "add -ou %s -ct %s -co %s -attr %s -val '%s'\n", ou1, mct2, co1, attr1, insval >> CreCOCom;
             co_attr_tab_add[ou1, mct2, co1, attr1] = 1;
             cre_ou_used[ou]=1;
           }else if ((file_ct_attr_tab[mct2,attr1,"P"]==1) && (type=="P")){
             printf "add -ou %s -ct %s -co %s -attr %s\n", ou1, mct2, co1, attr1>> CreCOCom;
             co_attr_tab_add[ou1, mct2, co1, attr1] = 1;
             cre_ou_used[ou]=1;
           }
           }
         } 
       }            
  
       if ((co_spec_attr_tab[ou, ct, co, attr] == 1) && (ct_tab[ct] == 1) && ((ct_in_history_tab[ct] == 1) || (attr_in_history_tab[ct,attr] == 1))) {
         # ============================================================================
         # remove CT/CO with attribute from OU
         # ============================================================================

         printf "DnfInfo: CT=%s ATTR=%s used in OU=%s within CO=%s (REMOVE).\n", ct, attr, ou, co >> logFile;
         printf "DnfInfo: CT=%s ATTR=%s used in OU=%s within CO=%s will be removed.\n", ct, attr, ou, co >> infologFile;
         printf "rem -ou %s -ct %s -co %s -attr %s\n", ou1, ct1, co1, attr1 >> RemCOCom;
         # ============================================================================
         # remember OUs in which a CO was found
         # ============================================================================
         co_spec_attr_tab[ou, ct, co, attr]=0; 
         rem_ou_used[ou]=1;
       }
    }
    
    for (i in mig_co_attr_tab_add){
      n = split(i, fields, SUBSEP);
      ou = fields[1];
      oct = fields[2]
      nct = fields[3];
      co = fields[4];
      attr = fields[5];
      #printf "CO_ATTR_TAB: DnfInfo: OU=%s CT=%s CO=%s Attr=%s Type=%s.\n", ou, ct, co, attr, type;
      ou1 = ou;
      n = gsub("_", strBSUL, ou1);
      n = gsub("%", strBSPC, ou1);
      oct1 = oct;
      n = gsub("_", strBSUL, oct1);
      n = gsub("%", strBSPC, oct1);
      nct1 = nct;
      n = gsub("_", strBSUL, nct1);
      n = gsub("%", strBSPC, nct1);
      co1 = co;
      n = gsub("_", strBSUL, co1);
      n = gsub("%", strBSPC, co1);
      attr1 = attr;
      n = gsub("_", strBSUL, attr1);
      n = gsub("%", strBSPC, attr1);
      for (j in file_ct_attr_tab) {
        #printf "j=%s\n", j;
        n = split(j, fields, SUBSEP);
        ctn = fields[1];
        n = gsub("_", strBSUL, ctn);
        n = gsub("%", strBSPC, ctn);
        attrn = fields[2];
        n = gsub("_", strBSUL, attrn);
        n = gsub("%", strBSPC, attrn);
        typen = fields[3];
        if ((ctn == nct1) && (supval_in_his_tab[nct1,attrn]!=1) && (ct_attr_tab[oct1,attrn,typen]!=1) && (mig_co_attr_tab_add[ou1, oct1, nct1, co1, attrn] !=1)){
          insval = "<your_value>"; 
       	  if ((file_ct_attr_tab[ctn,attrn,"R"]==1) && (co_attr_tab_add[ou1, ctn, co, attrn] !=1 )){
             defval_found = 0;             
             for (k in defval_in_his_tab){
               # ============================================================================
               # Special section for default value setting also in migrate CT table
               # ============================================================================
               n = split(k, fields, SUBSEP);
               mdct1 = fields[1];
               mdattr1 = fields[2];
               defval = fields[3];
               if ((ctn == mdct1) && (attrn == mdattr1)){ 
                 insval = defval;
                 defval_found = 1;
               }
             }
             for (k in refval_in_his_tab){
               # ============================================================================
               # Special section for reference value setting also in migrate CT table
               # ============================================================================
               n = split(k, fields, SUBSEP);
               mrct1 = fields[1];
               mrattr1 = fields[2];
               refval = fields[3];
               if ((ctn == mrct1) && (attrn == mrattr1)) insval = refval;
             }
      	   #printf "CO_ATTR_TAB: DnfInfo: OU=%s CT=%s CO=%s Attr=%s Type=%s.\n", ou, ct, co, attr, type;
           #printf "MIG_CT_TAB: DnfInfo: CT1=%s CT2=%s.\n", mct1, mct2;
           printf "DnfInfo: CT=%s ATTR=%s VAL=%s used in OU=%s within CO=%s (MIGRATE).\n", ct, attr, insval, ou, co >> logFile;
           printf "DnfInfo: CT=%s ATTR=%s VAL=%s used in OU=%s within CO=%s will be migrated.\n", ct, attr, insval, ou, co >> infologFile;
       	    if (defval_found == 0) printf ";" >> CreCOCom;
            if (index(insval, " ")==0) printf "add -ou %s -ct %s -co %s -attr %s -val %s\n", ou1, nct1, co, attrn, insval >> CreCOCom;
            else printf "add -ou %s -ct %s -co %s -attr %s -val %s\n", ou1, nct1, co, attrn, insval >> CreCOCom;
            co_attr_tab_add[ou1, nct1, co1, attrn] = 1;
            co_attr_tab_add[ou1, nct1, co, attrn] = 1;
            mig_co_attr_tab_add[ou1, oct1, nct1, co1, attrn] = 1;
            cre_ou_used[ou]=1;
          } else if ((file_ct_attr_tab[ctn,attrn,"P"]==1) && (co_attr_tab_add[ou1, ct1, co1, attrn] !=1 )) {
            printf "add -ou %s -ct %s -co %s -attr %s\n", ou1, ctn, co, attrn>> CreCOCom;
            co_attr_tab_add[ou1, ctn, co1, attrn] = 1;
            co_attr_tab_add[ou1, ctn, co, attrn] = 1;
            mig_co_attr_tab_add[ou1, oct1, nct1, co1, attrn] = 1;
            cre_ou_used[ou]=1;
          }
        }  
      }
    } 

    # ============================================================================
    # Create all CTs with their attributes which exist in file but not in system
    #
    # Remember those being migrated by setting
    #   file_ct_tab[ct,desc] = 0
    #   file_ct_attr_tab[ct,attr,type] = 0;
    # Addiditionally for all found in file and system set:
    #   file_ct_tab[ct,desc] = 0;
    #   ct_tab[ct] = 0;
    # ============================================================================

    for (i in file_ct_tab) {
      n = split(i, fields, SUBSEP);
      ct = fields[1];
      desc = fields[2];
      #printf "DnfInfo: CT=%s DESC=%s\n", ct, desc;
      if (ct_tab[ct] == 1) {
        # ============================================================================
        # mark that this ct which exists in file and system is not relevant for migration
        # ============================================================================
        #printf "CT=%s has been migrated (nothing)\n", ct;
        ct_tab[ct] = 0;
        file_ct_tab[ct,desc] = 0;
      } else {
        # ============================================================================
        # CT exists in file only --> Create CT and its attributes
        # ============================================================================
        printf "DnfInfo: CT=%s found in file but not in system (CREATE).\n\n", ct >> logFile;
        ct1 = ct;
        n = gsub("_", strBSUL, ct1);
        n = gsub("%", strBSPC, ct1);
        printf "cre -ct %s -desc %s\n", ct1, desc >> CreCTCom;
        # which attributes belong to this ct?
        for (j in file_ct_attr_tab) {
          n = split(j, fields, SUBSEP);
          ct_to_comp = fields[1];
          attr = fields[2];
          type = fields[3];
          if ((ct_to_comp == ct)&&(file_ct_attr_tab[ct_to_comp,attr,type] == 1)) {
            attr1  = attr;
            n = gsub("_", strBSUL, attr1);
            n = gsub("%", strBSPC, attr1);
            printf "add -ct %s -attr %s -type %s\n", ct1, attr1, type >> CreCTCom;
            printf "DnfInfo: CT=%s ATTR=%s TYPE=%s included (ADD).\n", ct, attr, type >> logFile;
            #mark that this attribute has been migrated
            file_ct_attr_tab[ct,attr,type] = 0;
          }
        }
        # ============================================================================
        # mark that this ct has been migrated (created)
        # ============================================================================
        #printf "CT=%s has been migrated (created)\n", ct;
        file_ct_tab[ct,desc] = 0;
        cre_ct_used[ct]=1;
      }
      #printf "System=%s\n", ct_attr_tab[ct,attr,type];
    }    

    # ============================================================================
    # Remove all attributes from CTs and corresponding COs which exist in system
    # but not in file
    # ============================================================================

    for (i in ct_attr_tab) {
      #printf "i=%s\n", i;
      n = split(i, fields, SUBSEP);
      ct = fields[1];
      attr = fields[2];
      type = fields[3];

      if ((ct_in_history_tab[ct] == 1)||(ct_in_product_tab[ct] == 1)||(attr_in_product_tab[ct,attr] == 1)) {
        # for all which are not migrated yet
        if (ct_attr_tab[ct,attr,type] == 1) {
          #printf "DnfInfo: OU=%s CT=%s Attr=%s Type=%s.\n", ou, ct, attr, type;
          # ============================================================================
          # does the current ct from the system exist in the file as well?
          # ============================================================================
          if (file_ct_attr_tab[ct,attr,type] == 1) {
            # ============================================================================
            # mark that this attr which exists in file and system is not relevant for migration
            # ============================================================================
            #printf "CT=%s ATTR=%s TYPE=%s has been migrated (nothing)\n", ct, attr, type;
            ct_attr_tab[ct,attr,type] = 0;
            file_ct_attr_tab[ct,attr,type] = 0;
          } else {
            # ============================================================================
            # migrate this attr which exists in system but not in file
            # ============================================================================
            found=0;

            # ============================================================================
            # Objects based on the type using this attribute existent?
            # ============================================================================
            for (j in co_attr_tab) {
              n = split(j, fields, SUBSEP);
              ou = fields[1];
              ct_to_comp = fields[2];
              co = fields[3];
              attr_to_comp = fields[4];
              type_to_comp = fields[5];
              val = fields[6];
              if ((ct_to_comp == ct) && (attr_to_comp == attr) && (type_to_comp == type) && (co_spec_attr_tab[ou, ct_to_comp, co, attr] == 1) ) {
                # ============================================================================
                # remember OUs identified, and remove Attribute from CO
                # ============================================================================
                ou1 = ou;
                n = gsub("_", strBSUL, ou1);
                n = gsub("%", strBSPC, ou1);
                ct1 = ct;
                n = gsub("_", strBSUL, ct1);
                n = gsub("%", strBSPC, ct1);
                co1 = co;
                n = gsub("_", strBSUL, co1);
                n = gsub("%", strBSPC, co1);
                attr1 = attr;
                n = gsub("_", strBSUL, attr1);
                n = gsub("%", strBSPC, attr1);
                printf "DnfInfo: CT=%s ATTR=%s TYPE=%s found for CO=%s in OU=%s (REMOVE).\n", ct, attr, type, co, ou >> logFile;
                printf "DnfInfo: CT=%s ATTR=%s TYPE=%s found for CO=%s in OU=%s and will be removed.\n", ct, attr, type, co, ou >> infologFile;
                printf "rem -ou %s -ct %s -co %s -attr %s\n", ou1, ct1, co1, attr1 >> RemCOCom;
                co_spec_attr_tab[ou, ct_to_comp, co, attr]=0;
                rem_ou_used[ou]=1;

              }
            }
            ct1 = ct;
            n = gsub("_", strBSUL, ct1);
            n = gsub("%", strBSPC, ct1);
            attr1 = attr;
            n = gsub("_", strBSUL, attr1);
            n = gsub("%", strBSPC, attr1);
            #printf "DnfInfo: CT=%s ATTR=%s Type=%s found in system but not in file (REMOVE).\n", ct, attr, type;
            printf "DnfInfo: CT=%s ATTR=%s Type=%s found in system but not in file (REMOVE).\n", ct, attr, type >> logFile;
            printf "DnfInfo: CT=%s ATTR=%s Type=%s found in system but not in file and will be removed.\n", ct, attr, type >> infologFile;
            printf "rem -ct %s -attr %s\n", ct1, attr1 >> RemCTCom;

            rem_ct_used[ct]=1;
            # ============================================================================
            # mark that this attr which exists in system but not in file has been migrated
            # ============================================================================
            #printf "CT=%s ATTR=%s TYPE=%s has been migrated (removed)\n", ct, attr, type;
            ct_attr_tab[ct,attr,type] = 0;
          }
        }
      } else {
        #printf "DnfInfo: CT=%s removal ignored, because not in product.\n", ct;
      }
    }

    # ============================================================================
    # Remove all CT/ATTRs assignment which in history file from current RO
    # ============================================================================

    for (i in ro_ct_co_tab) {
      n = split(i, fields, SUBSEP);
      ro = fields[1];
      ct = fields[2];
      co = fields[3];
      attr = fields[4];
      if ((ct_tab[ct] == 1) && (ct_in_history_tab[ct] == 1)){
        # ============================================================================
        # migrate this CT/CO/ATTR which CT exists in system but not in file
        # ============================================================================
        printf "DnfInfo: RO=%s CT=%s CO=%s ATTR=%s found in system but not in file (REMOVE).\n", ro, ct, co, attr >> logFile;
        printf "DnfInfo: RO=%s CT=%s CO=%s ATTR=%s found in system but not in file and will be removed.\n", ro, ct, co, attr >> infologFile;
        printf "rem -ro %s -ct %s -co %s -attr %s\n", ro, ct, co, attr >> RemRoCom;
        rem_ro_used[ro]=1;
        # ============================================================================
        # mark that this attr which exists in system but not in file has been migrated
        # ============================================================================
        #printf "RO=%s CT=%s CO=%s ATTR=%s has been migrated (removed)\n", ro, ct, co, attr;       
        ro_ct_co_tab[ro,ct,co,attr] = 0;    
      }
    }
          
    # ============================================================================
    # delete all CT in history file.
    # ============================================================================
          
    for (ct in ct_tab) {
      #printf "DnfInfo: CT=%s\n", ct;
      if ((ct_tab[ct] == 1) && (ct_in_history_tab[ct] == 1)) {
        # ============================================================================
        # Delete CT and mark that this ct has been migrated (deleted)
        # ============================================================================
        ct1 = ct;
        n = gsub("_", strBSUL, ct1);
        n = gsub("%", strBSPC, ct1);
        printf "DnfWarning: CT=%s found in system but not in file (DELETE).\n\n", ct  >> logFile;
        printf "DnfWarning: CT=%s found in system but not in file. CT will be deleted.\n\n", ct  >> infologFile;
        printf "del -ct %s\n", ct1 >> RemCTCom;
        #printf "CT=%s has been migrated (deleted)\n", ct, attr, type;
        ct_tab[ct] = 0;
        rem_ct_used[ct]=1;
          
      } else {
        #printf "DnfInfo: CT=%s removal ignored, because not in product.\n", ct;
      }
    }

    # ============================================================================
    # Add all attributes to CTs and corresponding COs which exist in file
    # but not in system
    # ============================================================================

    for (i in file_ct_attr_tab) {
      #printf "i=%s\n", i;
      n = split(i, fields, SUBSEP);
      ct = fields[1];
      attr = fields[2];
      type = fields[3];

      # for all which are not migrated yet
      if (file_ct_attr_tab[ct,attr,type] == 1) {

        ct1 = ct;
        n = gsub("_", strBSUL, ct1);
        n = gsub("%", strBSPC, ct1);

        attr1 = attr;
        n = gsub("_", strBSUL, attr1);
        n = gsub("%", strBSPC, attr1);

        if (ct_attr_tab[ct,attr,type] != 1) {
          #printf "DnfInfo: CT=%s Attr=%s Type=%s exists only in file.\n", ct, attr, type;
          printf "DnfInfo: CT=%s ATTR=%s TYPE=%s found (ADD).\n", ct, attr, type >> logFile;
          printf "add -ct %s -attr %s -type %s\n", ct1, attr1, type >> CreCTCom;
          cre_ct_used[ct]=1;
          for (j in co_attr_tab) {
            n = split(j, fields, SUBSEP);
            ou = fields[1];
            ct_to_comp = fields[2];
            co = fields[3];
            attr_to_comp = fields[4];
            type_to_comp = fields[5];
            val = fields[6];
              ou2 = ou;
              n = gsub("_", strBSUL, ou2);
              n = gsub("%", strBSPC, ou2);
              ct2 = ct_to_comp;
              n = gsub("_", strBSUL, ct2);
              n = gsub("%", strBSPC, ct2);
              co2 = co;
              n = gsub("_", strBSUL, co2);
              n = gsub("%", strBSPC, co2);              
              attr2 = attr_to_comp;
              n = gsub("_", strBSUL, attr2);
              n = gsub("%", strBSPC, attr2);
              type2 = type_to_comp;
              val2 = val;
              n = gsub("_", strBSUL, val2);
              n = gsub("%", strBSPC, val2);                 
            #printf "CO_ATTR_TAB: DnfInfo: OU=%s CT=%s CO=%s Attr=%s Type=%s.\n", ou, ct_to_comp, co, attr_to_comp, type_to_comp;
            if ((type=="R") && (supval_in_his_tab[ct1,attr1]!=1) && (ct1==ct_to_comp) && (co_attr_tab[ou, ct1, co, attr1, type_to_comp, val]!=1) && (co_attr_tab_add[ou, ct_to_comp, co, attr1]!= 1)){
       	       #printf "file_ct_attr_tab: %s\n", file_ct_attr_tab[mct2,attr1,"R"] >> CreCOCom;
       	       insval="<your_value>";
               defval_found = 0;             
               for (k in defval_in_his_tab){
                 # ============================================================================
                 # Special section for default value setting also in migrate CT table
                 # ============================================================================
                 n = split(k, fields, SUBSEP);
                 mdct1 = fields[1];
                 mdattr1 = fields[2];
                 defval = fields[3];
                 if ((ct1 == mdct1) && (attr1 == mdattr1)){
                    insval = defval;
                    defval_found = 1;
                 }
               }
               for (k in refval_in_his_tab){
                 # ============================================================================
                 # Special section for reference value setting also in migrate CT table
                 # ============================================================================
                 n = split(k, fields, SUBSEP);
                 mrct1 = fields[1];
                 mrattr1 = fields[2];
                 refval = fields[3];
                 if ((ct1 == mrct1) && (attr1 == mrattr1)) insval = refval;
               }
      	       #printf "CO_ATTR_TAB: DnfInfo: OU=%s CT=%s CO=%s Attr=%s Type=%s.\n", ou, ct, co, attr, type;
               #printf "MIG_CT_TAB: DnfInfo: CT1=%s CT2=%s.\n", mct1, mct2;
               printf "DnfInfo: CT=%s ATTR=%s VAL=%s used in OU=%s within CO=%s (MIGRATE).\n", ct, attr, insval, ou, co >> logFile;
               printf "DnfInfo: CT=%s ATTR=%s VAL=%s used in OU=%s within CO=%s will be migrated.\n", ct, attr, insval, ou, co >> infologFile;
       	       if (defval_found == 0) printf ";" >> CreCOCom;
       	       if (index(insval, " ")==0) printf "add -ou %s -ct %s -co %s -attr %s -val %s\n", ou2, ct1, co2, attr1, insval >> CreCOCom;
               else printf "add -ou %s -ct %s -co %s -attr %s -val '%s'\n", ou2, ct1, co2, attr1, insval>> CreCOCom;
               #printf "co=%s,co2=%s\n", co, co2>> CreCOCom;
               co_attr_tab_add[ou2, ct1, co, attr1] = 1;
               co_attr_tab_add[ou2, ct1, co2, attr1] = 1;
               cre_ou_used[ou2]=1;
            }
          }
        }
        # mark that this attr which exists in file but not in system has been migrated
        #printf "CT=%s ATTR=%s TYPE=%s has been migrated (added)\n", ct, attr, type;
        file_ct_attr_tab[ct,attr,type] = 0;
      }
    }

    # ============================================================================
    # Create all Roles with their CT/CO/ATTR which exist in file but not in system
    # ============================================================================

    for (i in file_ro_tab) {
      n = split(i, fields, SUBSEP);
      ro = fields[1];
      #printf "DnfInfo: Ro=%s\n", ro;
      if (ro_tab[ro] == 1) {
        # ============================================================================
        # mark that this role which exists in file and system is not relevant for migration
        # ============================================================================
        #printf "RO=%s has been migrated (nothing)\n", ro;
        ro_tab[ro] = 0;
        file_ro_tab[ro] = 0;
      } else {
        # ============================================================================
        # Role exists in file only --> Create Role and its CT/CO/ATTR
        # ============================================================================
        printf "DnfInfo: Ro=%s found in file but not in system (CREATE).\n\n", ro >> logFile;
        printf "cre -ro %s\n", ro >> CreRoCom;
        # which CT/CO/ATTR belongs to this role?
        for (j in file_ro_ct_co_tab) {
          n = split(j, fields, SUBSEP);
          ro_to_comp = fields[1];
          ct = fields[2];
          co = fields[3];
          attr = fields[4];
          #printf "DnfInfo: RO1=%s RO2=%s CT=%s CO=%s ATTR=%s .\n", ro, ro_to_comp, ct, co, attr;
          if (ro_to_comp == ro) {
            printf "add -ro %s -ct %s -co %s -attr %s\n", ro, ct, co, attr >> CreRoCom;
            printf "DnfInfo: RO=%s CT=%s CO=%s ATTR=%s included (ADD).\n", ro, ct, co, attr >> logFile;
            #mark that this attribute has been migrated
            file_ro_ct_co_tab[ro,ct,co,attr] = 0;
          }
        }
        # ============================================================================
        # mark that this ro has been migrated (created)
        # ============================================================================
        #printf "Ro=%s has been migrated (created)\n", ro;
        file_ro_tab[ro] = 0;
        cre_ro_used[ro] = 1;
      }
      #printf "System=%s\n", ro_ct_co_tab[ro,ct,co,attr];
    }

    ro = "DnfEfaSender";
    if (ro_tab[ro] == 1 ){
      # ============================================================================
      # Hard code for Alishan EFAS->MSIF migration for ro DnfEfaSender
      # ============================================================================
      ct = "DnfEfaFtAccessControl";
      co = "*";
      attr = "rcv";
      if (ro_ct_co_tab[ro,ct,co,attr] == 0){
        #printf "DnfInfo: RO=%s CT=%s CO=%s Attr=%s exists only in file.\n", ro, ct, co, attr;

        printf "DnfInfo: RO=%s CT=%s CO=%s ATTR=%s found (ADD).\n", ro, ct, co, attr >> logFile;
        printf "add -ro %s -ct %s -co %s -attr %s\n", ro, ct, co, attr >> CreRoCom;
        cre_ro_used[ro]=1;
        ro_ct_co_tab[ro,ct,co,attr] == 1
      }
      ct = "DnfEfaSWIFTDn";
      co = "*";
      attr = "sign";
      if (ro_ct_co_tab[ro,ct,co,attr] == 0){
        #printf "DnfInfo: RO=%s CT=%s CO=%s Attr=%s exists only in file.\n", ro, ct, co, attr;

        printf "DnfInfo: RO=%s CT=%s CO=%s ATTR=%s found (ADD).\n", ro, ct, co, attr >> logFile;
        printf "add -ro %s -ct %s -co %s -attr %s\n", ro, ct, co, attr >> CreRoCom;
        cre_ro_used[ro]=1;
        ro_ct_co_tab[ro,ct,co,attr] == 1
      }
      ct = "DnfEfaSWIFTDn";
      co = "*";
      attr = "encr";
      if (ro_ct_co_tab[ro,ct,co,attr] == 0){
        #printf "DnfInfo: RO=%s CT=%s CO=%s Attr=%s exists only in file.\n", ro, ct, co, attr;

        printf "DnfInfo: RO=%s CT=%s CO=%s ATTR=%s found (ADD).\n", ro, ct, co, attr >> logFile;
        printf "add -ro %s -ct %s -co %s -attr %s\n", ro, ct, co, attr >> CreRoCom;
        cre_ro_used[ro]=1;
        ro_ct_co_tab[ro,ct,co,attr] == 1
      }
     }
     
    ro = "SWIFTNetEfaSnFOperator";
    if (ro_tab[ro] == 1 ){
      # ============================================================================
      # Hard code for Alishan EFAS->MSIF migration for ro SWIFTNetEfaSnFOperator 
      # ============================================================================
      ct = "DnfEfaCmdAccessControl";
      co = "DnfEfaSwiftOpAccessControl";
      attr = "acquire";
      if (ro_ct_co_tab[ro,ct,co,attr] == 0){
        #printf "DnfInfo: RO=%s CT=%s CO=%s Attr=%s exists only in file.\n", ro, ct, co, attr;

        printf "DnfInfo: RO=%s CT=%s CO=%s ATTR=%s found (ADD).\n", ro, ct, co, attr >> logFile;
        printf "add -ro %s -ct %s -co %s -attr %s\n", ro, ct, co, attr >> CreRoCom;
        cre_ro_used[ro]=1;
        ro_ct_co_tab[ro,ct,co,attr] == 1
      }
      ct = "DnfEfaCmdAccessControl";
      co = "DnfEfaSwiftOpAccessControl";
      attr = "release";
      if (ro_ct_co_tab[ro,ct,co,attr] == 0){
        #printf "DnfInfo: RO=%s CT=%s CO=%s Attr=%s exists only in file.\n", ro, ct, co, attr;

        printf "DnfInfo: RO=%s CT=%s CO=%s ATTR=%s found (ADD).\n", ro, ct, co, attr >> logFile;
        printf "add -ro %s -ct %s -co %s -attr %s\n", ro, ct, co, attr >> CreRoCom;
        cre_ro_used[ro]=1;
        ro_ct_co_tab[ro,ct,co,attr] == 1
      }
      ct = "DnfEfaCmdAccessControl";
      co = "DnfEfaSwiftOpAccessControl";
      attr = "status";
      if (ro_ct_co_tab[ro,ct,co,attr] == 0){
        #printf "DnfInfo: RO=%s CT=%s CO=%s Attr=%s exists only in file.\n", ro, ct, co, attr;

        printf "DnfInfo: RO=%s CT=%s CO=%s ATTR=%s found (ADD).\n", ro, ct, co, attr >> logFile;
        printf "add -ro %s -ct %s -co %s -attr %s\n", ro, ct, co, attr >> CreRoCom;
        cre_ro_used[ro]=1;
        ro_ct_co_tab[ro,ct,co,attr] == 1
      }
      ct = "DnfEfaCmdAccessControl";
      co = "DnfEfaSwiftOpAccessControl";
      attr = "subscribe";
      if (ro_ct_co_tab[ro,ct,co,attr] == 0){
        #printf "DnfInfo: RO=%s CT=%s CO=%s Attr=%s exists only in file.\n", ro, ct, co, attr;

        printf "DnfInfo: RO=%s CT=%s CO=%s ATTR=%s found (ADD).\n", ro, ct, co, attr >> logFile;
        printf "add -ro %s -ct %s -co %s -attr %s\n", ro, ct, co, attr >> CreRoCom;
        cre_ro_used[ro]=1;
        ro_ct_co_tab[ro,ct,co,attr] == 1
      }
      ct = "DnfEfaCmdAccessControl";
      co = "DnfEfaSwiftOpAccessControl";
      attr = "query.snlid";
      if (ro_ct_co_tab[ro,ct,co,attr] == 0){
        #printf "DnfInfo: RO=%s CT=%s CO=%s Attr=%s exists only in file.\n", ro, ct, co, attr;

        printf "DnfInfo: RO=%s CT=%s CO=%s ATTR=%s found (ADD).\n", ro, ct, co, attr >> logFile;
        printf "add -ro %s -ct %s -co %s -attr %s\n", ro, ct, co, attr >> CreRoCom;
        cre_ro_used[ro]=1;
        ro_ct_co_tab[ro,ct,co,attr] == 1
      }
      ct = "DnfEfaSnFQueue";
      co = "*";
      attr = "*";
      if (ro_ct_co_tab[ro,ct,co,attr] == 0){
        #printf "DnfInfo: RO=%s CT=%s CO=%s Attr=%s exists only in file.\n", ro, ct, co, attr;

        printf "DnfInfo: RO=%s CT=%s CO=%s ATTR=%s found (ADD).\n", ro, ct, co, attr >> logFile;
        printf "add -ro %s -ct %s -co %s -attr %s\n", ro, ct, co, attr >> CreRoCom;
        cre_ro_used[ro]=1;
        ro_ct_co_tab[ro,ct,co,attr] == 1
      }
    }
          
    # ============================================================================
    # Remove all CT/CO/ATTR from Roles which exist in system but not in file
    # ============================================================================

    for (i in ro_ct_co_tab) {
      #printf "i=%s\n", i;
      n = split(i, fields, SUBSEP);
      ro = fields[1];
      ct = fields[2];
      co = fields[3];
      attr = fields[4];

      if ((((ro_in_product_tab[ro] == 1)||(ro_in_history_tab[ro] == 1)) && ((ct_in_product_tab[ct] == 1) || (ct_in_history_tab[ct] == 1))) || (file_ro_tab[ro] != 1)) {
        #printf "Ro=%s CT=%s CO=%s ATTR=%s\n", ro, ct, co, attr;
        # for all which are not migrated yet
        if (ro_ct_co_tab[ro,ct,co,attr] == 1) {
          #printf "DnfInfo: Ro=%s CT=%s CO=%s Attr=%s.\n", ro, ct, co, attr;
          # ============================================================================
          # does the current ro from the system exist in the file as well?
          # ============================================================================
          if (file_ro_ct_co_tab[ro,ct,co,attr] == 1) {
            # ============================================================================
            # mark that this CT/CO/ATTR which exists in file and system is not relevant for migration
            # ============================================================================
            #printf "Ro=%s CT=%s CO=%s ATTR=%s has been migrated (nothing)\n", ro, ct, co, attr;
            ro_ct_co_tab[ro,ct,co,attr] = 0;
            file_ro_ct_co_tab[ro,ct,co,attr] = 0;
          } else if (ro != "DnfEfaSender" && ro != "SWIFTNetEfaSnFOperator"){
            # ============================================================================
            # migrate this CT/CO/ATTR which exists in system but not in file
            # ============================================================================
            found=0;
            #printf "DnfInfo: RO=%s CT=%s CO=%s ATTR=%s found in system but not in file (REMOVE).\n", ro, ct, co, attr >> logFile;
            #printf "DnfInfo: RO=%s CT=%s CO=%s ATTR=%s found in system but not in file and will be removed.\n", ro, ct, co, attr >> infologFile;
            #printf "rem -ro %s -ct %s -co %s -attr %s\n", ro, ct, co, attr >> RemRoCom;
            #rem_ro_used[ro]=1;
            # ============================================================================
            # mark that this attr which exists in system but not in file has been migrated
            # ============================================================================
            #printf "RO=%s CT=%s CO=%s ATTR=%s has been migrated (removed)\n", ro, ct, co, attr;
            ro_ct_co_tab[ro,ct,co,attr] = 0;
          } 
        }
      } else {
        #printf "DnfInfo: RO=%s removal ignored, because not in product.\n", ro;
      }
    }

    # ============================================================================
    # Add all CT/CO/ATTR to Roles which exist in file but not in system
    # ============================================================================

    for (i in file_ro_ct_co_tab) {
      #printf "i=%s\n", i;
      n = split(i, fields, SUBSEP);
      ro = fields[1];
      ct = fields[2];
      co = fields[3];
      attr = fields[4];

      # for all which are not migrated yet
      if (file_ro_ct_co_tab[ro,ct,co,attr] == 1) {
        #printf "DnfInfo: RO=%s CT=%s CO=%s Attr=%s exists only in file.\n", ro, ct, co, attr;

        printf "DnfInfo: RO=%s CT=%s CO=%s ATTR=%s found (ADD).\n", ro, ct, co, attr >> logFile;
        printf "add -ro %s -ct %s -co %s -attr %s\n", ro, ct, co, attr >> CreRoCom;
        cre_ro_used[ro]=1;
        # mark that this attr which exists in file but not in system has been migrated
        #printf "RO=%s CT=%s CO=%s ATTR=%s has been migrated (added)\n", ro, ct, co, attr;
        file_ro_ct_co_tab[ro,ct,co,attr] = 0;
      }
    }


    # ============================================================================
    # for all Roles used for creating
    # ============================================================================

    for (ro in cre_ro_used) {
      if (cre_ro_used[ro] == 1) {
        CreRoEntry = 1;
        printf "com -ro %s\n", ro >> CreRoCom;
        printf "app -ro %s\n", ro >> CreRoApp;
        cre_ro_used[ro] = 0;
      }
    }


    # ============================================================================
    # for all Roles used for removing
    # ============================================================================

    for (ro in rem_ro_used) {
      if (rem_ro_used[ro] == 1) {
        RemRoEntry = 1;
        printf "com -ro %s\n", ro >> RemRoCom;
        printf "app -ro %s\n", ro >> RemRoApp;
        rem_ro_used[ro] = 0;
      }
    }


    # ============================================================================
    # for all CTs used for creating
    # ============================================================================

    for (ct in cre_ct_used) {
      if (cre_ct_used[ct] == 1) {
        CreCTEntry = 1;
        ct1 = ct;
        n = gsub("_", strBSUL, ct1);
        n = gsub("%", strBSPC, ct1);
        printf "com -ct %s\n", ct1 >> CreCTCom;
        printf "app -ct %s\n", ct1 >> CreCTDep;
        printf "dep -ct %s\n", ct1 >> CreCTDep;
        cre_ct_used[ct] = 0;
      }
    }


    # ============================================================================
    # for all CTs used for removing
    # ============================================================================

    for (ct in rem_ct_used) {
      if (rem_ct_used[ct] == 1) {
        RemCTEntry = 1;
        ct1 = ct;
        n = gsub("_", strBSUL, ct1);
        n = gsub("%", strBSPC, ct1);
        printf "com -ct %s\n", ct1 >> RemCTCom;
        printf "app -ct %s\n", ct1 >> RemCTDep;
        printf "dep -ct %s\n", ct1 >> RemCTDep;
        rem_ct_used[ct] = 0;
      }
    }


    # ============================================================================
    # for all OUs used for creating
    # ============================================================================

    for (ou in cre_ou_used) {
      if (cre_ou_used[ou] == 1) {
        CreCOEntry = 1;
        ou1 = ou;
        n = gsub("_", strBSUL, ou1);
        n = gsub("%", strBSPC, ou1);
        printf "com -ou %s\n", ou1 >> CreCOCom;
        printf "app -ou %s\n", ou1 >> CreCODep;
        printf "dep -ou %s\n", ou1 >> CreCODep;
      }
    }


    # ============================================================================
    # for all OUs used for attributes with values
    # ============================================================================

    for (ou in com_cre_ou_used) {
      if (com_cre_ou_used[ou] == 1 && cre_ou_used[ou] == 0) {
        CreCOEntry = 1;
        ou1 = ou;
        n = gsub("_", strBSUL, ou1);
        n = gsub("%", strBSPC, ou1);
        printf ";com -ou %s\n", ou1 >> CreCOCom;
        printf ";app -ou %s\n", ou1 >> CreCODep;
        printf ";dep -ou %s\n", ou1 >> CreCODep;
        com_cre_ou_used[ou] = 0;
      }
    }


    # ============================================================================
    # for all OUs used for removing
    # ============================================================================

    for (ou in rem_ou_used) {
      if (rem_ou_used[ou] == 1) {
        RemCOEntry = 1;
        ou1 = ou;
        n = gsub("_", strBSUL, ou1);
        n = gsub("%", strBSPC, ou1);
        printf "com -ou %s\n", ou1 >> RemCOCom;
        printf "app -ou %s\n", ou1 >> RemCODep;
        printf "dep -ou %s\n", ou1 >> RemCODep;
        rem_ou_used[ou] = 0;
      }
    }


    # ============================================================================
    # Delete files not used
    # ============================================================================

    if (CreRoEntry == 0) {
      system("rm " CreRoCom);
      system("rm " CreRoApp);
    } else {
      rc = 1;
    }

    if (RemRoEntry == 0) {
      system("rm " RemRoCom);
      system("rm " RemRoApp);
    } else {
      rc = 1;
    }

    if (CreCTEntry == 0) {
      system("rm " CreCTCom);
      system("rm " CreCTDep);
    } else {
      rc = 1;
    }

    if (RemCTEntry == 0) {
      system("rm " RemCTCom);
      system("rm " RemCTDep);
    } else {
      rc = 1;
    }

    if (CreCOEntry == 0) {
      system("rm " CreCOCom);
      system("rm " CreCODep);
    } else {
      rc = 1;
    }

    if (RemCOEntry == 0) {
      system("rm " RemCOCom);
      system("rm " RemCODep);
    } else {
      rc = 1;
    }

    if (ValEntry == 0) {
      system("rm " ValCom);
      system("rm " ValDep);
    } else {
      rc = 1;
    }
  }

  exit rc;
}

